## fermi-lite 0.1

=== Makefile ===
CC=			gcc
CFLAGS=		-g -Wall -O2 -Wno-unused-function #-fno-inline-functions -fno-inline-functions-called-once
CPPFLAGS=
INCLUDES=	
OBJS=		kthread.o misc.o \
			bseq.o htab.o bfc.o \
			rle.o rope.o mrope.o rld0.o \
			unitig.o mag.o bubble.o ksw.o
PROG=		fml-asm
LIBS=		-lm -lz -lpthread

.SUFFIXES:.c .o

.c.o:
		$(CC) -c $(CFLAGS) $(CPPFLAGS) $(INCLUDES) $< -o $@

all:$(PROG)

fml-asm:libfml.a example.o
		$(CC) $(CFLAGS) $^ -o $@ -L. -lfml $(LIBS)

libfml.a:$(OBJS)
		$(AR) -csru $@ $(OBJS)

clean:
		rm -fr gmon.out *.o ext/*.o a.out $(PROG) *~ *.a *.dSYM session*

depend:
		(LC_ALL=C; export LC_ALL; makedepend -Y -- $(CFLAGS) $(DFLAGS) -- *.c)

# DO NOT DELETE

bfc.o: htab.h kmer.h internal.h fml.h kvec.h ksort.h
bseq.o: fml.h kseq.h
bubble.o: mag.h kstring.h fml.h kvec.h ksw.h internal.h khash.h
example.o: fml.h
htab.o: htab.h kmer.h khash.h
ksw.o: ksw.h
mag.o: mag.h kstring.h fml.h kvec.h internal.h kseq.h khash.h ksort.h
misc.o: internal.h fml.h kstring.h rle.h mrope.h rope.h rld0.h mag.h kvec.h
misc.o: htab.h kmer.h khash.h
mrope.o: mrope.h rope.h
rld0.o: rld0.h
rle.o: rle.h
rope.o: rle.h rope.h
unitig.o: kvec.h kstring.h rld0.h mag.h fml.h internal.h ksort.h

=== debian/changelog ===
fermi-lite (0.1-9ubuntu1) focal; urgency=medium

  * debian/patches/ensure-signed-comparison: Ensure that our variable
    checking for >= 0 is signed.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 17 Mar 2020 01:09:47 -0700

fermi-lite (0.1-9) unstable; urgency=medium

  * Team upload.
  * Mark libfml{0,-dev} as Multi-Arch: same
  * Add armel to the -latomic group

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 15 Feb 2020 13:58:17 +0100

fermi-lite (0.1-8) unstable; urgency=medium

  * Team upload.
  * Fix compatability on mipsel, m68k, powerpc, and sh4 by using __sync instead
    of __atomic
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 12 (routine-update)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 15 Feb 2020 13:18:41 +0100

fermi-lite (0.1-7) unstable; urgency=medium

  * Team upload.
  * Add -latomic for those archs that need it

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 14 Dec 2019 15:33:59 +0100

fermi-lite (0.1-6) unstable; urgency=medium

  * Team upload.
  * Enable for all architectures using simde
  * Ship a symbols file

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 13 Dec 2019 18:04:33 +0100

fermi-lite (0.1-5) unstable; urgency=medium

  [ Steffen Möller ]
  * Add new d/u/metadata file

  [ Sascha Steinbiss ]
  * Update Vcs-* fields with Salsa addresses.
  * Bump Standards-Version.
  * Remove unnecessary Testsuite field.
  * Use debhelper 11.
  * Improve hardening.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 04 Jul 2018 23:40:50 +0200

fermi-lite (0.1-4) unstable; urgency=medium

  * Upload to unstable

 -- Andreas Tille <tille@debian.org>  Sun, 18 Jun 2017 08:12:35 +0200

fermi-lite (0.1-3) experimental; urgency=medium

  * Team upload.
  * Avoid name space conflict with bwa

 -- Andreas Tille <tille@debian.org>  Thu, 02 Feb 2017 10:59:28 +0100

fermi-lite (0.1-2) unstable; urgency=medium

  * Autopkgtest: build example outside of upstream source tree.
  * Restrict architectures to those with SSE2 support.
    See also upstream's comment at https://github.com/lh3/fermi-lite/issues/4

 -- Sascha Steinbiss <satta@debian.org>  Thu, 04 Aug 2016 05:37:30 +0000

fermi-lite (0.1-1) unstable; urgency=low

  * Initial packaging (Closes: #832757)

 -- Sascha Steinbiss <satta@debian.org>  Thu, 28 Jul 2016 22:26:11 +0000

=== debian/control ===
Source: fermi-lite
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sascha Steinbiss <satta@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               d-shlibs,
               zlib1g-dev,
               help2man
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/fermi-lite
Vcs-Git: https://salsa.debian.org/med-team/fermi-lite.git
Homepage: https://github.com/lh3/fermi-lite

Package: fml-asm
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         zlib1g
Description: tool for assembling Illumina short reads in small regions
 Fml-asm is a command-line tool for assembling Illumina short reads in regions
 from 100bp to 10 million bp in size, based on the fermi-lite library.
 It is largely a light-weight in-memory version of fermikit without
 generating any intermediate files. It inherits the performance, the relatively
 small memory footprint and the features of fermikit. In particular, fermi-lite
 is able to retain heterozygous events and thus can be used to assemble diploid
 regions for the purpose of variant calling.

Package: libfml0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         zlib1g
Description: library for assembling Illumina short reads in small regions
 Fermi-lite is a standalone C library tool for assembling Illumina short
 reads in regions from 100bp to 10 million bp in size.
 .
 This package contains a shared library offering the fermi-lite API to custom C
 programs.

Package: libfml-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libfml0 (= ${binary:Version}),
         zlib1g-dev,
         ${devlibs:Depends}
Description: development headers for libfml
 Fermi-lite is a standalone C library tool for assembling Illumina short
 reads in regions from 100bp to 10 million bp in size.
 .
 This package contains the C library headers for using libfml in custom tools,
 along with a static library.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
export DEB_CFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
export DEB_CXXFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mipsel powerpc sh4))
  export LDLIBS=-latomic
endif

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -f fml-asm.1

override_dh_auto_install:
	ln -s libfml.so.* libfml.so
	d-shlibmove --commit \
                    --multiarch \
                    --devunversioned \
                    --movedev "fml.h" /usr/include/ \
                    --movedev "bfc.h"  /usr/include/fml \
                    --movedev "htab.h" /usr/include/fml \
                    --movedev "kmer.h"  /usr/include/fml \
                    --movedev "internal.h" /usr/include/fml \
                    --movedev "khash.h" /usr/include/fml \
                    --movedev "kvec.h" /usr/include/fml \
                    --movedev "ksort.h" /usr/include/fml \
                    libfml.so

override_dh_installman:
	help2man --version-string='0.1' \
          -n 'assemble Illumina short reads in small regions' \
          -N --no-discard-stderr -h '' ./fml-asm > fml-asm.1
	dh_installman

## fermi-lite 0.1+git20190320.b499514

=== debian/changelog ===
fermi-lite (0.1+git20190320.b499514-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 16:47:30 +0200

fermi-lite (0.1+git20190320.b499514-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * Team upload.
  * Switch to upstream HEAD using gitmode in watch file
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Use the libsimde-dev package instead of our code copy

  [ Andreas Tille ]
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 08 Jan 2021 10:47:39 +0100

fermi-lite (0.1-13) unstable; urgency=medium

  * Fix package to build with gcc-10 (Closes: #957198)

 -- Nilesh Patra <npatra974@gmail.com>  Sat, 18 Apr 2020 22:59:03 +0530

fermi-lite (0.1-12) unstable; urgency=medium

  * Team upload.
  * debian/patches/sync_instead_of_atomic: fix logic and re-enable (fetch the
    previous value, not the new one). Fixes build on mipsel.
  * Added a basic package time test & autopkgtest to confirm the patch using
    fml-asm

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 30 Mar 2020 10:55:37 +0200

fermi-lite (0.1-11) unstable; urgency=medium

  [ Steve Langasek ]
  * Ensure that our variable checking for >= 0 is signed
    Closes: #954127

 -- Andreas Tille <tille@debian.org>  Sat, 28 Mar 2020 19:33:46 +0100

fermi-lite (0.1-10) unstable; urgency=medium

  * Team upload.
  * Revert change: Fix compatibility on mipsel, m68k, powerpc, and sh4 by using
    __sync instead of __atomic from 0.1-8 since it breaks ariba
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Thu, 12 Mar 2020 14:23:57 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,19 @@
 Source: fermi-lite
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Sascha Steinbiss <satta@debian.org>
+Uploaders: Sascha Steinbiss <satta@debian.org>, Nilesh Patra <npatra974@gmail.com>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                d-shlibs,
                zlib1g-dev,
+               libsimde-dev,
                help2man
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/fermi-lite
 Vcs-Git: https://salsa.debian.org/med-team/fermi-lite.git
 Homepage: https://github.com/lh3/fermi-lite
+Rules-Requires-Root: no
 
 Package: fml-asm
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -35,3 +35,9 @@
           -n 'assemble Illumina short reads in small regions' \
           -N --no-discard-stderr -h '' ./fml-asm > fml-asm.1
 	dh_installman
+
+override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	./fml-asm test/MT-simu.fq.gz > MT.fq
+	test "$$(wc -l < MT.fq)" = "4"
+endif

=== debian/watch ===
version=4

opts="mode=git,pretty=0.1+git%cd.%h" \
    https://github.com/lh3/fermi-lite.git HEAD

#https://github.com/lh3/fermi-lite/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## fermi-lite 0.1+git20221215.85f159e

=== debian/changelog ===
fermi-lite (0.1+git20221215.85f159e-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Cleanup after testing
    Closes: #1044647
  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.7.0 (routine-update)
  * Do not move header files away from source repository
    Closes: #1049564

 -- Andreas Tille <tille@debian.org>  Sat, 14 Dec 2024 19:47:40 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: fermi-lite
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Sascha Steinbiss <satta@debian.org>, Nilesh Patra <npatra974@gmail.com>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders: Sascha Steinbiss <satta@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -9,7 +8,7 @@
                zlib1g-dev,
                libsimde-dev,
                help2man
-Standards-Version: 4.5.1
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/fermi-lite
 Vcs-Git: https://salsa.debian.org/med-team/fermi-lite.git
 Homepage: https://github.com/lh3/fermi-lite

=== debian/rules ===
--- 
+++ 
@@ -20,14 +20,6 @@
 	d-shlibmove --commit \
                     --multiarch \
                     --devunversioned \
-                    --movedev "fml.h" /usr/include/ \
-                    --movedev "bfc.h"  /usr/include/fml \
-                    --movedev "htab.h" /usr/include/fml \
-                    --movedev "kmer.h"  /usr/include/fml \
-                    --movedev "internal.h" /usr/include/fml \
-                    --movedev "khash.h" /usr/include/fml \
-                    --movedev "kvec.h" /usr/include/fml \
-                    --movedev "ksort.h" /usr/include/fml \
                     libfml.so
 
 override_dh_installman:
@@ -40,4 +32,5 @@
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	./fml-asm test/MT-simu.fq.gz > MT.fq
 	test "$$(wc -l < MT.fq)" = "4"
+	rm -f MT.fq
 endif

=== debian/watch ===
version=4

opts="mode=git,pretty=0.1+git%cd.%h" \
    https://github.com/lh3/fermi-lite.git HEAD

#https://github.com/lh3/fermi-lite/releases .*/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
